//*****************************************************************************************//
//**********************************VER 1.0 data:20190524**********************************//
//**********************************    author : fred    **********************************//
//********************************** ADC UART demo code   **********************************//
//********************************** reference the note  **********************************//
//**************************TX1 SEND the AD convert result in 115200 baud rate*************//
//*****************************************************************************************//

#include <CMS/CMS8S5880.H>

//***************define constant******************//

#define 		volt_VBG	1200
#define			ADCH		0x0F5				//enable&clock&convert EX channel
#define			ADVBG		0x0BF				//enable&clock&convert internal channel
#define			NUM_AN		5
//*******************variable*********************//

bit F_ADC,F_send;
u8	ADCH_SW;
long result_ADC_VBG,result_ADC_CH;
long volt_AN;

//*******************initial*********************//

void ADC_init();								//ADC function initinal
void INT_init();								//interrupt initial
void ADC_INT();									//F_ADC:converter over;
void UART1_INIT();								//the BAUD relate the system clock
void UART1_INT();								//F_transmit:UART transmit over F_receive:UART receive over
void	delay();
//******************* main  *********************//

void main()
{
	int i=0,j=0,F_send=0;
	long MAX_ADC_CH,MIN_ADC_CH,SUM_ADC_CH;
	
	UART1_INIT();
	ADC_init();									//ADC function initinal 
	INT_init();									//interrupt initinal
	
	while(1)
	{
		
		clrwdt();

//******volt_AN is the voltage of the input channel*****//
//******the data divide 1000 is the real voltage *******//
		
		for(i=0;i<10;i++)
		{
			
			ADCON0			|= 0x02;				//start AD converter
			
			while(F_ADC==0)
			{
				if(0 == (--j))
					return;
			}				
			if(F_ADC)
			{
				result_ADC_CH	= (ADRESH<<8)+ADRESL;//read the convert result
				F_ADC			= 0;
			
			if(i==0)
			{
				MAX_ADC_CH		= result_ADC_CH;
				MIN_ADC_CH		= result_ADC_CH;
				SUM_ADC_CH		= 0;
			}
			if(result_ADC_CH>MAX_ADC_CH)
			{
				MAX_ADC_CH		= result_ADC_CH;	//catch the MAX convert data
			}
			if(result_ADC_CH<MAX_ADC_CH)
			{
				MIN_ADC_CH		= result_ADC_CH;	//catch the MIN convert data
			}
			
				SUM_ADC_CH		+= result_ADC_CH;	//read the SUM data 
			}
			
		}
		if(i>9)
		{
			result_ADC_CH	= (SUM_ADC_CH-MAX_ADC_CH-MIN_ADC_CH)>>3;
		
			F_send			= 0;				
			SBUF1			= result_ADC_CH;
	
		while(F_send==0)
			
			{
				clrwdt();		//if application, here must add overtime
			}

			F_send			= 0;				
			SBUF1			= result_ADC_CH/256;
	
		while(F_send==0)
			
			{
				clrwdt();		//if application, here must add overtime
			}

		}
			

	
		}	
}

//void	delay()
//{
//	long k;
//	for(k=0;k<32768;k++)
//	{
//		_nop6_();
//		_nop6_();
//	}
//}
/*************************************************
function name: ADC_init()
function work: initial the ADC function
input data   : null
output data  : null
note		 : setting the ADC function
*************************************************/
void ADC_init()
{

	#define		pin0	0x01;
	#define		pin1	0x02;
	#define		pin2	0x04;
	#define		pin3	0x08;

	#define		pin4	0x10;
	#define		pin5	0x20;
	#define		pin6	0x40;
	#define		pin7	0x80;	
	
//=======e.g. if use AN0+AN3,in the sample port THE value is pin0+pin3========//	
	

//	P0TRIS		&=	~pin4;		// input mode
//	P0ANS		|=	pin4;		//AN4--P04	P04	SWITCH TO AN4
//	P04CFG		=	0x01;

	P0TRIS		&=	~pin5;		// input mode
//	P0ANS		|=	pin5;		//AN5--P05	P05	SWITCH TO AN5
	P05CFG		=	0x01;

//	P1TRIS		&=	~pin3;		// input mode 
//	P1ANS		|=	pin3;		//AN6--P13	P13	SWITCH TO AN6
//	P13CFG		=	0x01;

//	P1TRIS		&=	~pin4;		// input mode 
//	P1ANS		|=	pin4;		//AN7--P14	P14	SWITCH TO AN7
//	P14CFG		=	0x01;

//	P2TRIS		&=	~pin2;		// input mode
//	P2ANS		|=	pin2;		//AN8--P22	P22	SWITCH TO AN8
//	P22CFG		=	0x01;

//	P2TRIS		&=	~pin3;		// input mode
//	P2ANS		|=	pin3;		//AN9--P23	P23	SWITCH TO AN9
//	P23CFG		=	0x01;

//	P2TRIS		&=	~pin4;		// input mode
//	P2ANS		|=	pin4;		//AN10--P24	P24	SWITCH TO AN10
//	P24CFG		=	0x01;

//	P2TRIS		&=	~pin5;		// input mode
//	P2ANS		|=	pin5;		//AN12--P25	P25	SWITCH TO AN11
//	P25CFG		=	0x01;

//	P2TRIS		&=	~pin6;		// input mode
//	P2ANS		|=	pin6;		//AN12--P26	P26	SWITCH TO AN12
//	P26CFG		=	0x01;

//	P3TRIS		&=	~pin1;		// input mode
//	P3ANS		|=	pin1;		//AN13--P31	P31	SWITCH TO AN13	
//	P31CFG		=	0x01;

//	P3TRIS		&=	~pin2;		// input mode
//	P3ANS		|=	pin2;		//AN14--P32	P32	SWITCH TO AN14	
//	P32CFG		=	0x01;

//	P3TRIS		&=	~pin5;		// input mode
//	P3ANS		|=	pin5;		//AN16--P35	P35	SWITCH TO AN16	
//	P35CFG		=	0x01;

//	P3TRIS		&=	~pin6;		// input mode
//	P3ANS		|=	pin6;		//AN17--P36	P36	SWITCH TO AN17	
//	P36CFG		=	0x01;

//	P1TRIS		&=	~pin5;		// input mode
//	P1ANS		|=	pin5;		//AN18--P15	P15	SWITCH TO AN18
//	P15CFG		=	0x01;

//	P1TRIS		&=	~pin6;		// input mode
//	P1ANS		|=	pin6;		//AN19--P16 P16	SWITCH TO AN19
//	P16CFG		=	0x01;

//	P1TRIS		&=	~pin7;		// input mode
//	P1ANS		|=	pin7;		//AN20--P17	P17	SWITCH TO AN20
//	P17CFG		=	0x01;

//	P2TRIS		&=	~pin1;		// input mode
//	P2ANS		|=	pin1;		//AN21--P21	P21	SWITCH TO AN21
//	P21CFG		=	0x01;

//	P2TRIS		&=	~pin0;		// input mode
//	P2ANS		|=	pin0;		//AN22--P30	P30	SWITCH TO AN22
//	P30CFG		=	0x01;


//==============other register configure=====================//

	ADCON2		=	0x00;
	
	//bit7 0:disable HW trigger 1:enable HW trigger
	//bit6 0:external trigger pin selected ADCET0	1:external trigger pin selected ADCET1
	//bit5~4 ADC HW trigger source select 
	//		 00:PG0(PWM0)	01:PG2 (PWM2)	10:PG4 (PWM4)	11:ADCET0/ADCET1	
	//bit3~2 ADC HW trigger edge select
	//		 00:falling edge 01:rising edge 10:PWM period middle 11:PWM period end

	ADCON1		=	ADCH;		
	
	//bit7 	0:disable ADC IP  1:enable ADC IP
	//bit6~4:ADCKS<2:0> ADC clock select
	// 		000:f/2	001:f/4	010:f/8	011:f/16	100:f/32 101:f/64 110:f/128 111:f/256
	//bit3~0:ADCHS<3:0>: AN channel select
	//0000~1110:AN0~AN14		1111:AN15	reference for ADCON0.AN15SEL define
	
	if(NUM_AN<0x10)
	{
		ADCON0		=	0x40;
	}
	else
	{
		ADCON0		=	0x80;
	}
	
	//bit7 1: AN channel>=16 0: AN channel<16
	//bit6 0:left align	1:right align
	//bit5~4 AN15 select source bit 	00:VBG 01:OP0_O 10:OP1_O
	//bit1 ADGO 	0:can not write 1:start AD converter
	
	ADCMPC		=	0x00;
	
	//bit7 0:disable ADC CMP pwm fb function 1:enable 
	//bit6 0:ADRES>=ADCMP,ADCMPO=1;1:ADRES<ADCMP,ADCMPO=1
	//bit4 ADC CMP output bit 0:CMP output 0 1:CMP output 1
	//bit1~0 ADC HW trigger delay time bit9~8
	
	ADDLYL		=	0x00;
	
	//ADC HW trigger delay time bit7~0
	
	//the ADC result 
	//ADRESH/ADRESL
	//ADFM=0 ADRESH:ADRES11~ADRES4 ADRESL7~4:ADRES3~ADRES0
	//ADFM=1 ADRESH3~0:ADRES11~ADRES8 ADRESL:ADRES7~ADRES0
	
	//the CMP register
	//ADCMPH:D11~D4 ADCMPL BIT3~0:D3~D0
	
//	ADCON0		|=	0x02;			//start AD converter
	
//*****************************************************************//	
	
}

/*************************************************
function name: INT_init()
function work: initial the INT function
input data   : null
output data  : null
note		 : setting the interrupt function
*************************************************/
void INT_init()						//intterrupt initinal
{
	IE		=	0x40;
	
//Bit7	EA	Global interrupt enable bit 0:disable 1:enable
//Bit6	ES1	UART1 interrupt enable bit  0:disable 1:enable
//Bit5	ET2	Timer2 global interrupt enable bit  0:disable 1:enable
//Bit4	ES0	UART0 interrupt enable bit  0:disable 1:enable
//Bit3	ET1	Timer1 interrupt enable bit  0:disable 1:enable
//Bit2	EX1	INT1 interrupt enable bit  0:disable 1:enable
//Bit1	ET0	Timer0 interrupt enable bit  0:disable 1:enable
//Bit0	EX0	INT0 interrupt enable bit  0:disable 1:enable

	EIE2	=	0x10;
	
//Bit7	SPIIE	SPI enable interrupt bit 0:disable 1:enable
//Bit6	I2CIE	I2C enable interrupt bit 0:disable 1:enable
//Bit5	WDTIE	WDT enable interrupt bit 0:disable 1:enable
//Bit4	ADCIE	ADC enable interrupt bit 0:disable 1:enable
//Bit3	PWMIE	PWM enable interrupt bit 0:disable 1:enable(EIP2.PPWM must be the same as EIP1.PP3PWM)
//Bit1	ET4	 Timer4 enable interrupt bit 0:disable 1:enable
//Bit0	ET3	 Timer3 enable interrupt bit 0:disable 1:enable
 	
	EIP2	=	0x00;
	
//Bit7	PSPI	SPI interrupt priority control bit 0:high priority 1:low priority
//Bit6	PI2C	I2C interrupt priority control bit 0:high priority 1:low priority
//Bit5	PWDT	WDT interrupt priority control bit 0:high priority 1:low priority
//Bit4	PADC	ADC interrupt priority control bit 0:high priority 1:low priority
//Bit3	PPWM	PWM interrupt priority control bit 0:high priority 1:low priority
//Bit1	PT4  Timer4 interrupt priority control bit 0:high priority 1:low priority
//Bit0	PT3  Timer3 interrupt priority control bit 0:high priority 1:low priority


	EA		=	1;		//Bit7	EA	Global interrupt enable bit 0:disable 1:enable
	
}


/*************************************************
function name: ADC_INT()
function work: ADC INT sub function
input data   : null
output data  : null
note		 : interrupt function and set the flag
*************************************************/
void ADC_INT()		interrupt	ADC_VECTOR	
{
	EIF2		&=	0xEF;
	F_ADC		=	1;
		
}
/*************************************************
function name: UART1_INT()
function work: UART INT function
input data   : null
output data  : null
note		 : set the send and receive the data flag
*************************************************/
void UART1_INT()	interrupt	UART1_VECTOR
{

	if((SCON1&0x02)/0x02)						//transmit over
	{
		SCON1		&=	0x0FD;
		F_send		=	1;
	}
	if(SCON1&0x01)
	{
		SCON1		&=	0x0FE;

	}
}

/*************************************************
function name: UART1_INIT()
function work: initial the UART function
input data   : null
output data  : null
note		 : setting the UART1 function
*************************************************/
void UART1_INIT()								//BPS
{
//#define	MAIN_CLOCK_FREQ	16000000UL		//define the system clock frequence	
	
	FUNCCR 	|= 0x0a;						//clock from BRT
//	
//	P04CFG	= 0x02; 		   				//enable TX pin
//	P05CFG	= 0x02;							//enable RX pin
	
	P21CFG	= 0x02; 		   				//enable TX pin
	P35CFG	= 0x02;							//enable RX pin	

	SCON1 	= 0x40;							//UART 8bit asyn transmit enable
	SCON1 	|= 0x10;						//RX pin enable	
	
//Bit7~6	UnSM0~UnSM1 00:master synchronize 01:8 bit async baud rate veriable timer1/4
//						10:9bit async baud rate fsys/32 or fsys/64 11:9 bit async baud rate veriable
//Bit5	UnSM2	Multi-computer Communication control bit 0:disable 1:enable
//Bit4	UnREN	receive enable bit 0:disable 1:enable
//Bit3	UnTB8	trandmit 9-th data bit 0:bit=0 1:bit=1
//Bit2	UnRB8	receive 9-th data bit 0:bit=0 1:bit=1
//Bit1	TIn	transmit interrupt (SW clear)	1:transmit buffer is null ,can transmit the next data
//Bit0	RIn	receive interrupt (SW clear)	1:receive buffer is full ,after read,can receive the next data

	PCON	&= 0x7f;						//baud is the define rate
//	PCON	|= 0x40;						//baud is the double rate
	
//Bit7	SMOD0	UART1 baud rate multiplier bit;1= double UART1 baud rate;0=UART1 baud rate is normal.
//Bit6	SMOD1	UART1 baud rate multiplier bit;1= double UART1 baud rate;0=UART1 baud rate is normal.
	
	
	

	BRTCON	=  0x80;
	
#define value_set	65523

	BRTDL	=  value_set;
	BRTDH	=  value_set/256;
	
}