#include <CMS/CMS8S5880.H>
//*****************************************************************************************//
//**********************************VER 1.0 data:20190524**********************************//
//**********************************    author : fred    **********************************//
//*********************************** PWM  OUTPUT Setting*********************************//
//*****************************************************************************************//
//*********PWM output setting*******************//
//**************define constant******************//
//Edge alignment
//High time = (CMP + 1) * Tpwm
//Period = (PERIOD + 1) *Tpwm
//Duty cycle = (CMP+1)/(PERIOD+1)
//
//Center aligned symmetric count
//High time = (PERIODn * 2-CMPn * 2-1) * Tpwm
//Period = (PERIODn) * 2 * Tpwm
//Duty cycle = (PERIODn * 2-CMPn * 2-1) / (PERIODn * 2)
//CMPn=0 Duty cycle 100%;
//Center aligned asymmetric count
//High time = (PERIODn*2-CMPDn-CMPn-1)*Tpwm
//Period = (PERIODn) * 2 * Tpwm
//Duty cycle = (PERIODn*2-CMPDn-CMPn-1)/PERIODn*2
//CMPn=0&CMPDn=0 ,duty cycle 100%;
//*******************variable*********************//


//*******************initial*********************//

void PWM_init();								//PWM initial setting
void INT_init();								//interrupt initial
void PWM_INT();									//watch the PWM output pin

//******************* main  *********************//
void main()
{
	PWM_init();									//PWM initial
	INT_init();									//INT initial
	
	while(1)
	{
		clrwdt();
	}
}

/*************************************************
function name: PWM_init()
function work: initial the PWM function
input data   : null
output data  : null
note		 : watch the IO of the PWM output
*************************************************/
void PWM_init()
{
	PWMCON		=	0x00;
	
	//bit5~4 PWM mode 00:independent mode 01:complement mode 10:synchronize mode 11:reserved
	//bit3:groupe enable bit 1:PG0 control PG2/PG4 0:PG1control PG3/PG5
	//bit2:PWM Asymmetrical counting enable bit in center alignment 0:symmetry 1:asymmetric
	//bit1:alignment mode selected 0:edge alignment 1:center alignment
	
	PWMOE		=	0x03F;
	
	//bit5 PWM ch5 enable bit 0:disable 1:enable
	//bit4 PWM ch4 enable bit 0:disable 1:enable
	//bit3 PWM ch3 enable bit 0:disable 1:enable
	//bit2 PWM ch2 enable bit 0:disable 1:enable
	//bit1 PWM ch1 enable bit 0:disable 1:enable
	//bit0 PWM ch0 enable bit 0:disable 1:enable

//**switch IO pin to the PWM output**//
	
//	P00CFG		=	0x05;		//P00 switch to PWM0 output pin
	P13CFG		=	0x06;		//P13 switch to PWM0 output pin
//	P15CFG		=	0x05;		//P15 switch to PWM0 output pin

//	P1TRIS		|=	0x08;

//	P01CFG		=	0x05;		//P01 switch to PWM1 output pin
//	P05CFG		=	0x06;		//P05 switch to PWM1 output pin
	P14CFG		=	0x06;		//P14 switch to PWM1 output pin

//	P0TRIS		|=	0x20;
	
//	
//	P02CFG		=	0x05;		//P02 switch to PWM2 output pin
	P15CFG		=	0x06;		//P15 switch to PWM2 output pin
//	P24CFG		=	0x05;		//P24 switch to PWM2 output pin
//	
	P16CFG		=	0x06;		//P16 switch to PWM3 output pin
//	P23CFG		=	0x06;		//P23 switch to PWM3 output pin
//	
	P17CFG		=	0x06;		//P17 switch to PWM4 output pin
//	
//	P13CFG		=	0x05;		//P13 switch to PWM5 output pin
//	P22CFG		=	0x06;		//P22 switch to PWM5 output pin
	P36CFG		=	0x06;		//P36 switch to PWM5 output pin
	

	PWM01PSC	=	0x01;		
	
	//00:Prescaler clock stop, pwm0/1 counter stop 
	//other:Fpwm01= fsys/(PWM01PSC+1)
	
	PWM23PSC	=	0x01;		
	
	//00:Prescaler clock stop, pwm2/3 counter stop 
	//other:Fpwm23= fsys/(PWM23PSC+1)	
	
	PWM45PSC	=	0x01;		
	
	//00:Prescaler clock stop, pwm4/5 counter stop 
	//other:Fpwm45= fsys/(PWM01PSC+1)
	
	PWM0DIV		=	0x0FF;
	
	//PWM chn clock prescaler control bit
	//000:Fpwm0/2	001:Fpwm0/4	010:Fpwm0/8	011:Fpwm0/16	
	//100:Fpwm0		other:Fsys
	
	PWM1DIV		=	0x0FF;
	
	//PWM chn clock prescaler control bit
	//000:Fpwm1/2	001:Fpwm1/4	010:Fpwm1/8	011:Fpwm1/16	
	//100:Fpwm1		other:Fsys	
	
	PWM2DIV		=	0x0FF;
	
	//PWM chn clock prescaler control bit
	//000:Fpwm2/2	001:Fpwm2/4	010:Fpwm2/8	011:Fpwm2/16	
	//100:Fpwm2		other:Fsys

	PWM3DIV		=	0x0FF;
	
	//PWM chn clock prescaler control bit
	//000:FPWM3/2	001:FPWM3/4	010:FPWM3/8	011:FPWM3/16	
	//100:FPWM3		other:Fsys
	
	PWM4DIV		=	0x0FF;
	
	//PWM chn clock prescaler control bit
	//000:FPWM4/2	001:FPWM4/4	010:FPWM4/8	011:FPWM4/16	
	//100:FPWM4		other:Fsys

	PWM5DIV		=	0x0FF;
	
	//PWM chn clock prescaler control bit
	//000:FPWM5/2	001:FPWM5/4	010:FPWM5/8	011:FPWM5/16	
	//100:FPWM5		other:Fsys

	PWMLOADEN	=	0x03F;
	
	//Data loading of PWM channel n enables bit (n=0-5) (hardware reset after loading);
	//1 :It enables the loading period and duty cycle data (PERIODn, CMPn, CMPDn). 0:write 0 unefficient
	
	PWMPINV		=	0x00;
	
	//PWM channel n output polarity control bit (n=0-5);
	//1:Reverse output; 0:Normal output.

	PWMCNTM		=	0x03F;
	
	//PWM channel n counter mode control bit (n=0-5);
	//1: automatic loading mode;
	//0: One - shot mode.
	
	PWMCNTCLR	=	0x00;
	
	//PWM channel n counter reset control bit (n=0-5) (hardware auto-reset);
	//1:PWMn counter reset;
	//0: writing 0 is not valid.
	
	PWMP0L		=	0x00;
	PWMP0H		=	0x80;
	PWMP1L		=	0x00;
	PWMP1H		=	0x80;
	PWMP2L		=	0x00;
	PWMP2H		=	0x80;
	PWMP3L		=	0x00;
	PWMP3H		=	0x80;
	PWMP4L		=	0x00;
	PWMP4H		=	0x80;
	PWMP5L		=	0x00;
	PWMP5H		=	0x80;				//PWM period data,calculate read SPEC
	
	PWMD0L		=	0x01;
	PWMD0H		=	0x00;
	PWMD1L		=	0x02;
	PWMD1H		=	0x00;
	PWMD2L		=	0x03;
	PWMD2H		=	0x00;
	PWMD3L		=	0x04;
	PWMD3H		=	0x00;
	PWMD4L		=	0x05;
	PWMD4H		=	0x00;
	PWMD5L		=	0x06;
	PWMD5H		=	0x00;				//PWM duty data,calculate read SPEC

//	PWMDD0L		=	0x00;
//	PWMDD0H		=	0x20;
//	PWMDD1L		=	0x00;
//	PWMDD1H		=	0x20;
//	PWMDD2L		=	0x00;
//	PWMDD2H		=	0x20;
//	PWMDD3L		=	0x00;
//	PWMDD3H		=	0x20;
//	PWMDD4L		=	0x00;
//	PWMDD4H		=	0x20;
//	PWMDD5L		=	0x00;
//	PWMDD5H		=	0x20;				
	
//PWM channel n downward comparison data (duty ratio data under asymmetric counting)
	
	PWMDTE		=	0x00;
	
//bit2:Pwm4/5 channel dead time enable bit;1:enable 0:disable
//bit1:Pwm2/3 channel dead time enable bit;1:enable 0:disable
//bit0:Pwm0/1 channel dead time enable bit;1:enable 0:disable
	
	PWM01DT		=	0x00;				//dead time delay data register:(PWM01DT+1)*TPWM0
	PWM23DT		=	0x00;				//dead time delay data register:(PWM23DT+1)*TPWM2
	PWM45DT		=	0x00;				//dead time delay data register:(PWM45DT+1)*TPWM4
	
	PWMMASKE	=	0x00;				//PWMn mask output 0:PWM normal output 1:MASK DATA output(bit5~0)
	PWMMASKD	=	0x00;				//MASK output data 0:low output 1:high output
	
	PWMFBKC		=	0x00;
	
	//bit7 PWM FB interrupt control bit 0:disable 1:enable
	//bit6 PWM FB flag 0:no broke operation 1:broke operation(clear bit for write 0) 
	//bit5 1:Counter values will not be cleared when braking 0:Counter values will be cleared when braking
	//bit4 PWM SW FB signal start bit 0:disable 1:enable
	//bit3 PWM external hardware brake channel 1 (FB1) trigger level selection bit;1: high level;0: low level
	//bit2 PWM external hardware brake channel 0 (FB0) trigger level selection bit;1: high level;0: low level
	//bit1 PWM external hardware brake channel 1 (FB1) enable bit 1:enable 0:disable
	//bit1 PWM external hardware brake channel 0 (FB0) enable bit 1:enable 0:disable
	
	PWMFBKD		=	0x00;
	
	//PWM channel n brake data bit (n=0-5);
	//1:PWMn channel produces high output after brake operation;0:PWMn channel produces low output after brake operation

//*******************************************************************************************//

	PWMPIE		=	0x01;
	//PWM channel n periodic interrupt mask bit (n=0-5);1: enable interrupt;0: no interrupt;
	
	PWMPIF		=	0x00;					//SW clear the flag
	//PWM channel n periodic interrupt occur flag bit (n=0-5);1: interrupt occur;0: no interrupt occur;
	
	PWMZIE		=	0x00;
	//PWM channel n zeroic interrupt mask bit (n=0-5);1: enable interrupt;0: disable interrupt;

	PWMZIF		=	0x00;					//SW clear the flag
	//PWM channel n zeroic interrupt occur flag bit (n=0-5);1: interrupt occur;0: no interrupt occur;

	PWMUIE		=	0x00;
	//PWM channel n up compare interrupt mask bit (n=0-5);1: enable interrupt;0: disable interrupt;

	PWMUIF		=	0x00;					//SW clear the flag
	//PWM channel n up compare interrupt occur flag bit (n=0-5);1: interrupt occur;0: no interrupt occur;

	PWMDIE		=	0x00;
	//PWM channel n down compare interrupt mask bit (n=0-5);1: enable interrupt;0: disable interrupt;

	PWMDIF		=	0x00;					//SW clear the flag
	//PWM channel n down compare interrupt occur flag bit (n=0-5);1: interrupt occur;0: no interrupt occur;

	PWMCNTE		=	0x03F;
	//PWM channel n counter enables control bit (n=0-5);1=PWMn counter turned on (PWMn starts output);0=PWMn counter stop (write 0 is invalid).

}

/*************************************************
function name: INT_init()
function work: initial the INT function
input data   : null
output data  : null
note		 : setting the interrupt function
*************************************************/
void INT_init()						//intterrupt initinal
{
	IE		=	0x00;
	
//Bit7	EA	Global interrupt enable bit 0:disable 1:enable
//Bit6	ES1	UART1 interrupt enable bit  0:disable 1:enable
//Bit5	ET2	Timer2 global interrupt enable bit  0:disable 1:enable
//Bit4	ES0	UART0 interrupt enable bit  0:disable 1:enable
//Bit3	ET1	Timer1 interrupt enable bit  0:disable 1:enable
//Bit2	EX1	INT1 interrupt enable bit  0:disable 1:enable
//Bit1	ET0	Timer0 interrupt enable bit  0:disable 1:enable
//Bit0	EX0	INT0 interrupt enable bit  0:disable 1:enable
	
	EIE2	=	0x08;
	
//Bit7	SPIIE	SPI enable interrupt bit 0:disable 1:enable
//Bit6	I2CIE	I2C enable interrupt bit 0:disable 1:enable
//Bit5	WDTIE	WDT enable interrupt bit 0:disable 1:enable
//Bit4	ADCIE	ADC enable interrupt bit 0:disable 1:enable
//Bit3	PWMIE	PWM enable interrupt bit 0:disable 1:enable(EIP2.PPWM must be the same as EIP1.PP3PWM)
//Bit1	ET4	 Timer4 enable interrupt bit 0:disable 1:enable
//Bit0	ET3	 Timer3 enable interrupt bit 0:disable 1:enable

	EIP1	=	0x00;
	
//Bit7	PACMP	CMP interrupt priority control bit 0:high priority 1:low priority
//Bit3	PP3PWM	P3&PWM interrupt priority control bit 0:high priority 1:low priority(EIP2.PPWM must be the same as EIP1.PP3PWM)
//Bit2	PP2		P2 interrupt priority control bit 0:high priority 1:low priority
//Bit1	PP1		P1 interrupt priority control bit 0:high priority 1:low priority
//Bit0	PP0		P0 interrupt priority control bit 0:high priority 1:low priority
  	
	EIP2	=	0x00;
	
//Bit7	PSPI	SPI interrupt priority control bit 0:high priority 1:low priority
//Bit6	PI2C	I2C interrupt priority control bit 0:high priority 1:low priority
//Bit5	PWDT	WDT interrupt priority control bit 0:high priority 1:low priority
//Bit4	PADC	ADC interrupt priority control bit 0:high priority 1:low priority
//Bit3	PPWM	PWM interrupt priority control bit 0:high priority 1:low priority
//Bit1	PT4  Timer4 interrupt priority control bit 0:high priority 1:low priority
//Bit0	PT3  Timer3 interrupt priority control bit 0:high priority 1:low priority

	EA		=	1;		//Bit7	EA	Global interrupt enable bit 0:disable 1:enable
	
}
/*************************************************
function name: PWM_INT()
function work: PWM INT function
input data   : null
output data  : null
note		 : null
*************************************************/
void PWM_INT()		interrupt	PWM_VECTOR
{
	PWMPIF		=	0x00;

}