#include <CMS/CMS8S5880.H>
//*****************************************************************************************//
//**********************************VER 1.0 data:20190524**********************************//
//**********************************    author : fred    **********************************//
//*********************************** UART  send&receive***********************************//
//***************** receive 10 sample data and then send the data**************************//
//****************************reveive data and then send data *****************************//
//*****************************************************************************************//

//***********define constant*********************//

#define		MAIN_CLOCK_FREQ		16000000uL		//unit:Hz
#define		BAUD_RATE			9600
#define		divider				4				//4 or 12
#define		value_CNT			(256-(MAIN_CLOCK_FREQ*(((PCON&0x80)/0x80)+1)/32/divider/BAUD_RATE))

//*******************variable*********************//

bit	F_transmit,F_receive,F_transover;
u8	i,j,k,l,RECE_d[10];

//*******************initial*********************//

void UART0_INIT();								//the BAUD relate the system clock
void INT_init();								//interrupt initial
void UART0_INT();								//F_transmit:UART transmit over F_receive:UART receive over

//*******************MAIN*********************//

void main()
{
	i=0;
	j=k=l=0;
	
	UART0_INIT();								//initinal UART
	INT_init();									//initial INT enable or not
	
//	SBUF0=0x01;
	
	while(1)
	{
		clrwdt()								//clear WDT

//****if you want to transmit the receive data****//
//****please setting the 1, if not setting 0******//
 		
#if 0		
		if(F_receive==1)						//UART receive&send data
		{
			F_receive	= 0;
			RECE_d[k]	= SBUF0;
			k++;
			
		}
//		if(F_transmit  && (k>1))
//		{
//				F_transmit=0;
//				
//				SBUF0		= RECE_d[l];
//				l++;
//			if(l>2)
//				{
//					k=l=0;
//				}
//				
//		}
#endif

//**if you want to receive 10 data and then transmit**//
//*******please setting the 1, if not setting 0*******//
		
#if 1		
		if(F_transmit==1)						//UART transmit after receive data
		{
			j--;
			F_transmit	= 0;
			SBUF0	  	= RECE_d[9-j];		

		}
		if(F_receive==1)						//UART receive data 
		{
			F_receive	= 0;
			RECE_d[j]	= SBUF0;
			j++;
			if(j>9)
			{
				F_transmit=1;
			}
		}
#endif	
	}
}
/*************************************************
function name: UART0_INIT()
function work: initial the UART function
input data   : null
output data  : null
note		 : setting the UART0 function
*************************************************/
void UART0_INIT()								//BPS
{
//#define	MAIN_CLOCK_FREQ	16000000UL		//define the system clock frequence	
	
	P25CFG	= 0x02; 		   				//enable TX pin
	P26CFG	= 0x02;							//enable RX pin
	

	SCON0 	= 0x40;							//UART 8bit asyn transmit enable
	SCON0 	|= 0x10;						//RX pin enable	
	
//Bit7~6	UnSM0~UnSM1 00:master synchronize 01:8 bit async baud rate veriable timer1/4
//						10:9bit async baud rate fsys/32 or fsys/64 11:9 bit async baud rate veriable
//Bit5	UnSM2	Multi-computer Communication control bit 0:disable 1:enable
//Bit4	UnREN	receive enable bit 0:disable 1:enable
//Bit3	UnTB8	trandmit 9-th data bit 0:bit=0 1:bit=1
//Bit2	UnRB8	receive 9-th data bit 0:bit=0 1:bit=1
//Bit1	TIn	transmit interrupt (SW clear)	1:transmit buffer is null ,can transmit the next data
//Bit0	RIn	receive interrupt (SW clear)	1:receive buffer is full ,after read,can receive the next data

	PCON	&= 0x7f;						//baud is the define rate
	PCON	|= 0x80;						//baud is the double rate
	
//Bit7	SMOD0	UART0 baud rate multiplier bit;1= double UART0 baud rate;0=UART0 baud rate is normal.
//Bit6	SMOD1	UART1 baud rate multiplier bit;1= double UART1 baud rate;0=UART0 baud rate is normal.
	
	FUNCCR 	|= 0x05;						//clock from BRT
	

	BRTCON	=  0x80;
	
#define value_set	65523

	BRTDL	=  value_set;
	BRTDH	=  value_set/256;
	
}


/*************************************************
function name: INT_init()
function work: initial the INT function
input data   : null
output data  : null
note		 : setting the interrupt function
*************************************************/
void INT_init()									//intterrupt initinal
{
	IE		=	0x10;
	
//Bit7	EA	Global interrupt enable bit 0:disable 1:enable
//Bit6	ES1	UART1 interrupt enable bit  0:disable 1:enable
//Bit5	ET2	Timer2 global interrupt enable bit  0:disable 1:enable
//Bit4	ES0	UART0 interrupt enable bit  0:disable 1:enable
//Bit3	ET1	Timer1 interrupt enable bit  0:disable 1:enable
//Bit2	EX1	INT1 interrupt enable bit  0:disable 1:enable
//Bit1	ET0	Timer0 interrupt enable bit  0:disable 1:enable
//Bit0	EX0	INT0 interrupt enable bit  0:disable 1:enable

	IP		=	0x00;
	
//Bit6	PS1		UART1 interrupt priority control bit 0:high priority 1:low priority
//Bit5	PT2		Timer2 interrupt priority control bit 0:high priority 1:low priority
//Bit4	PS0		UART0 interrupt priority control bit 0:high priority 1:low priority
//Bit3	PT1		Timer1 interrupt priority control bit 0:high priority 1:low priority
//Bit2	PX1		INT1 interrupt priority control bit 0:high priority 1:low priority
//Bit1	PT0		Timer0 interrupt priority control bit 0:high priority 1:low priority
//Bit0	PX0		INT0 interrupt priority control bit 0:high priority 1:low priority

	EA		=	1;		//Bit7	EA	Global interrupt enable bit 0:disable 1:enable
	
}
/*************************************************
function name: UART0_INT()
function work: UART INT function
input data   : null
output data  : null
note		 : set the send and receive the data flag
*************************************************/
void UART0_INT()	interrupt	UART0_VECTOR
{

	if((SCON0&0x02)/0x02)						//transmit over
	{
		SCON0		&=	0x0FD;
		F_transmit	=	1;

		if(j==0)
		{
			F_transmit =0;
		}

	}
	if(SCON0&0x01)
	{
		SCON0		&=	0x0FE;
		P1_5		=	~P1_5;
		F_receive	=	1;
//		RECE_d[k]	= SBUF0;
//		k++;
//		if(k>1) SBUF0=RECE_d[l];
	
	}
}